Fapi_SetCertificate
Feature API

## Functions

TSS2_RC | Fapi_SetCertificate (FAPI_CONTEXT *context, char const *path, char const *x509certData)
TSS2_RC | Fapi_SetCertificate_Async (FAPI_CONTEXT *context, char const *path, char const *x509certData)
TSS2_RC | Fapi_SetCertificate_Finish (FAPI_CONTEXT *context)

## Detailed Description

FAPI functions to invoke SetCertificate either as one-call or in an asynchronous manner.

## Function Documentation

## Fapi_SetCertificate()

TSS2_RC Fapi_SetCertificate | ( | FAPI_CONTEXT * | context,
|  | char const * | path,
|  | char const * | x509certData )

One-Call function for Fapi_SetCertificate

Sets an x509 cert into the path of a key.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [in] | path | The path of the entity to be associated with the certificate
  [in] | x509certData | The certificate that is associated with the entity. If this is NULL an existing certificate will be removed from the entity

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context or path is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if path does not map to a FAPI entity.
  TSS2_FAPI_RC_BAD_KEY | if x509certData is invalid.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_TRY_AGAIN | if an I/O operation is not finished yet and this function needs to be called again.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.

## Fapi_SetCertificate_Async()

TSS2_RC Fapi_SetCertificate_Async | ( | FAPI_CONTEXT * | context,
|  | char const * | path,
|  | char const * | x509certData )

Asynchronous function for Fapi_SetCertificate

Sets an x509 cert into the path of a key.

Call Fapi_SetCertificate_Finish to finish the execution of this command.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [in] | path | The path of the entity to be associated with the certificate
  [in] | x509certData | The certificate that is associated with the entity. If this is NULL an existing certificate will be removed from the entity

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context or path is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if path does not map to a FAPI entity.
  TSS2_FAPI_RC_BAD_KEY | if x509certData is invalid.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.

## Fapi_SetCertificate_Finish()

TSS2_RC Fapi_SetCertificate_Finish | ( | FAPI_CONTEXT * | context | ) |

Asynchronous finish function for Fapi_SetCertificate

This function should be called after a previous Fapi_SetCertificate_Async.

Parameters

  [in,out] | context | The FAPI_CONTEXT

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_TRY_AGAIN | if the asynchronous operation is not yet complete. Call this function again later.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.